/* GETGUI.C    Simple GUI box invocable from shell scripts

*/
#define VERSION "1.3"
#include <stdio.h>
#define PROMPTMAX 2048
#define RESULTMAX 2048

main( argc, argv )
int argc;
char **argv;
{
int i;
char buttons[120];
char prompt[PROMPTMAX];
char initvalue[RESULTMAX];
char initfile[120];
char attime[40];
int  kfchars;
int  ebchars;
int  winx, winy;
double width, height;
char promptfile[120];
int  delaysec;
char winname[80];
int  pwmode;
char buf[512];
char result[RESULTMAX];
char parm[50];
char command[256];
char newlinemode[50];
char okstring[20];
int intmode;

strcpy( buttons, "" );
strcpy( prompt, "Your message here!" );
strcpy( initvalue, "" );
strcpy( attime, "" );
kfchars = 0;
ebchars = 0;
winx = 300; winy = 200;
width = 4.0; height = 3.2;
delaysec = 0;
strcpy( promptfile, "" );
strcpy( winname, "getgui" );
pwmode = 0;
strcpy( command, "" );
strcpy( newlinemode, "everyline" );
strcpy( initfile, "" );
strcpy( okstring, "OK" );
intmode = 0;

if( argc == 1 ) {
	fprintf( stderr, "Usage: getgui options\n\
   Desc:  Simple GUI box invocable from shell scripts, etc.\n\
          User's selection is written to standard output.\n\
 \n\
   Options (may be specified in any order):\n\
   -i			Interactive alarm clock mode \n\
   -prompt s            Display s as the prompt string (one or more lines)\n\
   -buttons blist       Display buttons.  blist is a comma delimited list of labels.\n\
   -keyinput nchars	Display a key data entry field nchars wide.  \n\
   -editbox nchars	Display a multi-line editbox.  Max length of response is nchars.\n\
   -initvalue s         Puts s into keyinput field or editbox as the initial value.\n\
   -initfile f          Loads editbox initial value from file f \n\
   -winloc x,y          Position upper left corner of gui window at pixel location x,y \n\
   -winsize w,h         Make gui window size w inches wide by h inches high \n\
   -promptfile f        Take the prompt text from file f \n\
   -delaysec s          Wait s seconds before displaying (egg timer mode) \n\
   -attime hh:mm     	Wait until time hh:mm before displaying (alarm clock mode) \n\
   -pw                  Causes the characters typed into a keyinput box to be invisible \n\
   -set attribute value Set various attributes (see man page) \n\
   -exec command        Display an 'in progress' message while executing command \n\
   -version             Print the version number and home page for getgui \n\
\n\
   This is version %s\n\
", VERSION );
	}

for( i = 1; i < argc; i++ ) {
	if( strcmp( argv[i], "-i" )==0 ) {
		intmode = 1;
		break;
		}
	else if( strcmp( argv[i], "-prompt" )==0 || strcmp( argv[i], "-p" )==0 ) {
		i++;
		if( i < argc ) strcpy( prompt, argv[i] );
		}
	else if( strncmp( argv[i], "-b", 2 )==0 ) {
		i++;
		if( i < argc ) strcpy( buttons, argv[i] );
		}
	else if( strncmp( argv[i], "-k", 2 )==0 ) {
		i++;
		if( i < argc ) sscanf( argv[i], "%d", &kfchars );
		}
	else if( strncmp( argv[i], "-ed", 3 )==0 ) {
		i++;
		if( i < argc ) sscanf( argv[i], "%d", &ebchars );
		}
	else if( strcmp( argv[i], "-initvalue" )==0 ) {
		i++;
		if( i < argc ) strcpy( initvalue, argv[i] );
		}
	else if( strcmp( argv[i], "-initfile" )==0 ) {
		i++;
		if( i < argc ) strcpy( initfile, argv[i] );
		}
	else if( strcmp( argv[i], "-winloc" )==0 ) {
		i++;
		if( i < argc ) sscanf( argv[i], "%d,%d", &winx, &winy );
		}
	else if( strcmp( argv[i], "-winsize" )==0 ) {
		i++;
		if( i < argc ) sscanf( argv[i], "%lf,%lf", &width, &height );
		}
	else if( strcmp( argv[i], "-promptfile" )==0 ) {
		i++;
		if( i < argc ) strcpy( promptfile, argv[i] );
		}
	else if( strncmp( argv[i], "-del", 4 )==0 ) {
		i++;
		if( i < argc ) delaysec = atoi( argv[i] );
		}
	else if( strncmp( argv[i], "-at", 3 )==0 ) {
		i++;
		if( i < argc ) strcpy( attime, argv[i] );
		}
	else if( strcmp( argv[i], "-winname" )==0 ) {
		i++;
		if( i < argc ) strcpy( winname, argv[i] );
		}
	else if( strcmp( argv[i], "-pw" )==0 ) pwmode = 1;
	else if( strcmp( argv[i], "-winname" )==0 ) {
		i++;
		if( i < argc ) strcpy( winname, argv[i] );
		}
	else if( strcmp( argv[i], "-exec" )==0 ) {
		i++;
		if( i < argc ) strcpy( command, argv[i] );
		}
	else if( strncmp( argv[i], "-ver", 4 )==0 || strncmp( argv[i], "-?", 2 )==0 ) { 
		fprintf( stderr, "getgui version %s (home page ploticus.sourceforge.net/getgui)\n", VERSION );
		fprintf( stderr, "For usage message type 'getgui' with no arguments.\n" );
		exit( 0 );
		}
	}

if( intmode ) {
	width = 5.0; height = 3.8;
	getgui_init( winname, width, height, winx, winy );
	strcpy( prompt, "" );
	getgui_editbox( "Enter message:", 200, newlinemode, "OK,Cancel", prompt );
	if( prompt[0] == 'C' ) exit( 0 );
	getgui_keyinput( "What time today should it pop up?\n\
		Use 24 hour notation, eg 8:30 or 15:00", "", 5, "OK,Cancel", attime );
	if( attime[0] == 'C' ) exit( 0 );
	sprintf( buf, "getgui: alarm set for %s.\n", attime );
	getgui_progress( buf, "" );
	sleep( 1 );
	getgui_progressclear();
	getgui_set( "invisible", "" );
	}


/* delay if requested.. */
if( delaysec > 0 ) sleep( delaysec );
else if( strlen( attime ) > 0 ) {
	int hr, min, sec, athr, atmin;
	/* check attime .. */
	if( strlen( attime ) < 4 || strlen( attime ) > 5 ) {
		fprintf( stderr, "getgui: invalid format for -attime (hh:mm expected)\n" );
		exit(1);
		}
	sscanf( attime, "%d:%d", &athr, &atmin );
	if( athr < 0 || athr > 23 || atmin < 0 || atmin > 59 ) {
		fprintf( stderr, "getgui: invalid -attime: hour=%d min=%d\n", athr, atmin );
		exit(1);
		}

	if( !intmode ) fprintf( stderr, "getgui: alarm set for %02d:%02d.\n", athr, atmin );

	while( 1 ) {
		systime( &hr, &min, &sec );
		if( hr == athr && min == atmin ) break;
		sleep( 55 );
		}
	}



/* handle prompt coming from a file.. */
if( strlen( promptfile ) > 0 ) {
	FILE *fp;
	fp = fopen( promptfile, "r" );
	if( fp == NULL ) 
		fprintf( stderr, "getgui: warning: cannot open -promptfile %s\n", promptfile );
	else 	{
		i = 0;
		while( fgets( buf, 511, fp ) != NULL ) {
			if( i + strlen( buf ) > PROMPTMAX ) break;
			strcpy( &prompt[i], buf );
			i+= strlen( buf );
			}
		fclose( fp );
		}
	}

/* handle initial value coming from a file.. */
if( strlen( initfile ) > 0 ) {
	FILE *fp;
	fp = fopen( initfile, "r" );
	if( fp == NULL ) 
		fprintf( stderr, "getgui: warning: cannot open -initfile %s\n", initfile );
	else 	{
		i = 0;
		while( fgets( buf, 511, fp ) != NULL ) {
			if( i + strlen( buf ) > RESULTMAX ) break;
			strcpy( &initvalue[i], buf );
			i+= strlen( buf );
			}
		fclose( fp );
		}
	}


/* open the GUI window.. */
if( intmode ) getgui_set( "visible", "" );
else getgui_init( winname, width, height, winx, winy );

if( pwmode ) getgui_set( "passwordmode", "1" );

/* look for any other -set args.. */
for( i = 1; i < argc; i++ ) {
	if( strcmp( argv[i], "-set" )==0 ) {
		i++;
		if( i < argc ) strcpy( parm, argv[i] );
		i++;
		if( i < argc ) {
			if( strcmp( parm, "newlinemode" )==0 ) strcpy( newlinemode, argv[i] );
			else getgui_set( parm, argv[i] );
			if( strcmp( parm, "okstring" )==0 ) strcpy( okstring, argv[i] );
			}
		}
	}

/* determine what type of gui field to put up.. */

if( strlen( command ) > 0 ) {
	getgui_progress( prompt, "" );
	system( command );
	getgui_progressclear();
	}

else if( kfchars > 0 ) getgui_keyinput( prompt, initvalue, kfchars, buttons, result );

else if( ebchars > 0 ) {
	if( strlen( initvalue ) > 0 ) strcpy( result, initvalue );
	else strcpy( result, "" );
	/* there MUST be an OK button */
	if( strlen( buttons ) < 1 ) strcpy( buttons, okstring );
	else	{
		strcpy( buf, buttons );
		for( i = 0; i < strlen( buf ); i++ ) if( buf[i] == ',' ) buf[i] = ' ';
		if( ! smember( okstring, buf )) {
			char buf2[300];
			sprintf( buf2, "%s,%s", okstring, buttons );
			strcpy( buttons, buf2 );
			}
		}
	getgui_editbox( prompt, ebchars, newlinemode, buttons, result );
	}

else if( strlen( buttons ) > 0 ) getgui_buttons( prompt, buttons, result );

else 	{
	getgui_buttons( prompt, okstring, result );
	exit(0);
	}

printf( "%s", result );
exit(0);
}

/* =========== */

systime( hour, min, sec )
int	*hour, *min, *sec ;
{
	int	tvec[2], *dtime ;

	time( tvec );
	dtime = (int *)localtime( tvec );
	*hour = *(dtime+2) ;
	*min = *(dtime+1)  ;
	*sec = *(dtime)  ;
}

/* smember() - returns 1 if string s is present as a token in string t,
		0 otherwise.  Auth: Steve Grubb */
smember( s, t )
char s[], t[];
{
char tok[100], *GL_getok();
int i;
i = 0;
while( 1 ) {
	strcpy( tok, GL_getok( t, &i ) );
	if( tok[0] == '\0' ) break;
	if( strcmp( tok, s ) == 0 ) return( 1 );
	}
return( 0 );
}


